#include <stdio.h>
#include <stdlib.h>

#define INT_N 9

void write_list_to_stream(int * list, int size);
int * read_list_from_stream();

int main(int argc, char *argv[])
{
    int * l = malloc(sizeof(int) * INT_N);
    for (int i = 0; i<INT_N; i++) {
        l[i] = i*INT_N;
    }

    write_list_to_stream(l, INT_N);

    read_list_from_stream();

    return 0;
}

void write_list_to_stream(int * list, int size) {
    FILE * f = fopen("out", "w+");
    char * lst = malloc(9+size%10);
    sprintf(lst, "list: [%d] ", size);
    fwrite(lst, 1, 10+size/10, f);
    free(lst);

    for (int i = 1; i<size; i++) {
        fprintf(f, "%d, ", list[i-1]);
    }
    fprintf(f, "%d", list[size-1]);

    fclose(f);
}

int * read_list_from_stream() {
    FILE * f = fopen("out", "r+");
    int size;
    fscanf(f, "list: [%d] ", &size);

    int * list = malloc(sizeof(int)*size);
    for (int i = 1; i<size; i++) {
        fscanf(f, "%d, ", &list[i-1]);
    }
    fscanf(f, "%d", &list[size-1]);

    for (int i = 0; i<size; i++) {
        printf("%d, ", list[i]);
    }

    fclose(f);

    return list;
}
